/*
 * 
 */
package fr.astec.entity.ergo.constraint;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import fr.astec.entity.ergo.expression.Expression;
import fr.astec.entity.ergo.keyword.ExpressionComparator;

// TODO: Auto-generated Javadoc
/**
 * The Class SingleValueConstraint.
 * 
 * @author Laurent CHARLOIS
 * @version 1.0
 */
@Entity
@Table(name = "ASTEC_ERGO_SINGLE_VALUE_CONSTRAINT")
@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
public class SingleValueConstraint extends ValueConstraint {

	/** The comparator. */
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "COMPARATOR", referencedColumnName = "ERGO_CLASS_ID")
	private ExpressionComparator	comparator;

	/** The value. */
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "VALUE", referencedColumnName = "ERGO_CLASS_ID")
	private Expression				value;

	/**
	 * Instantiates a new single value constraint.
	 */
	public SingleValueConstraint() {
	}

	/**
	 * Gets the comparator.
	 * 
	 * @return the comparator
	 */
	public ExpressionComparator getComparator() {
		return comparator;
	}

	/**
	 * Sets the comparator.
	 * 
	 * @param comparator
	 *            the new comparator
	 */
	public void setComparator(ExpressionComparator comparator) {
		this.comparator = comparator;
	}

	/**
	 * Gets the value.
	 * 
	 * @return the value
	 */
	public Expression getValue() {
		return value;
	}

	/**
	 * Sets the value.
	 * 
	 * @param value
	 *            the new value
	 */
	public void setValue(Expression value) {
		this.value = value;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.astec.ergo.ERGOClass#toOWL(java.lang.String)
	 */
	@Override
	public String toOWL(String prefix) {
		StringBuilder sb = new StringBuilder();
		sb.append("<" + prefix + "SingleValueConstraint rdf:ID=\"id_" + this.getId() + "\">");
		sb.append("\n");
		sb.append("\t");
		sb.append("<" + prefix + "comparator>" + comparator.toOWL(prefix) + "</" + prefix + "comparator>");
		sb.append("\n");
		sb.append("\t");
		sb.append("<" + prefix + "value>" + value.toOWL(prefix) + "</" + prefix + "value>");
		sb.append("\n");
		sb.append("</" + prefix + "SingleValueConstraint>");
		sb.append("\n");

		return sb.toString();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "SingleValueConstraint [comparator=" + comparator + ", value=" + value + "]";
	}

}
