/*
 * 
 */
package fr.astec.entity.ergo.expression;

import java.util.Collection;
import java.util.Vector;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.Table;

// TODO: Auto-generated Javadoc
/**
 * The Class PrimitiveNounPhrase.
 * 
 * @author Laurent
 * @version 1.0
 * @created 20-mai-2010 15:34:38
 */
@Entity
@Table(name = "ASTEC_ERGO_PRIMITIVE_NP")
@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
public class PrimitiveNounPhrase extends NounPhrase {

	/** The code. */
	@Column(name = "CODE", nullable = false)
	private String	code;

	/** The code system. */
	@Column(name = "CODE_SYSTEM", nullable = false)
	private String	codeSystem;

	/** The prefered name. */
	@Column(name = "PREFERED_NAME", nullable = false)
	private String	preferedName;

	/**
	 * Instantiates a new primitive noun phrase.
	 */
	public PrimitiveNounPhrase() {

	}

	/**
	 * Gets the code.
	 * 
	 * @return the code
	 */
	public String getCode() {
		return code;
	}

	/**
	 * Sets the code.
	 * 
	 * @param code
	 *            the new code
	 */
	public void setCode(String code) {
		this.code = code;
	}

	/**
	 * Gets the code system.
	 * 
	 * @return the code system
	 */
	public String getCodeSystem() {
		return codeSystem;
	}

	/**
	 * Sets the code system.
	 * 
	 * @param codeSystem
	 *            the new code system
	 */
	public void setCodeSystem(String codeSystem) {
		this.codeSystem = codeSystem;
	}

	/**
	 * Gets the prefered name.
	 * 
	 * @return the prefered name
	 */
	public String getPreferedName() {
		return preferedName;
	}

	/**
	 * Sets the prefered name.
	 * 
	 * @param preferedName
	 *            the new prefered name
	 */
	public void setPreferedName(String preferedName) {
		this.preferedName = preferedName;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.astec.ergo.ERGOClass#toOWL(java.lang.String)
	 */
	@Override
	public String toOWL(String prefix) {
		StringBuilder sb = new StringBuilder();
		sb.append("<" + prefix + "PrimitiveNounPhrase rdf:ID=\"id_" + this.getId() + "\">");
		sb.append("\n");
		sb.append("\t");
		sb.append("<" + prefix + "code rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">" + code + "</" + prefix + "code>");
		sb.append("\n");
		sb.append("\t");
		sb.append("<" + prefix + "preferedName rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">" + preferedName + "</" + prefix + "preferedName>");
		sb.append("\n");
		sb.append("\t");
		sb.append("<" + prefix + "codeSystem rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">" + codeSystem + "</" + prefix + "codeSystem>");
		sb.append("\n");
		sb.append("</" + prefix + "PrimitiveNounPhrase>");
		sb.append("\n");

		return sb.toString();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "PrimitiveNounPhrase [code=" + code + ", codeSystem=" + codeSystem + ", id=" + id + ", preferedName=" + preferedName + "]";
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.astec.ergo.expression.NounPhrase#getUsedId()
	 */
	@Override
	public Collection<Long> getUsedId() {
		Collection<Long> retValue = new Vector<Long>();
		retValue.add(this.id);
		return retValue;
	}

	/**
	 * Equals.
	 * 
	 * @param pnp
	 *            the pnp
	 * @return true, if successful
	 */
	public boolean equals(PrimitiveNounPhrase pnp) {
		if (pnp.getCode().equals(this.code) && pnp.getCodeSystem().equals(this.codeSystem)) {
			return true;
		}
		return false;
	}

}