/*
 * 
 */
package fr.astec.entity.ergo.statement;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.Table;

import fr.astec.entity.ergo.ERGOClass;

// TODO: Auto-generated Javadoc
/**
 * The Class ClinicalStatementTemplate.
 * 
 * @author Laurent
 * @version 1.0
 * @created 20-mai-2010 15:34:25
 */
@Entity
@Table(name = "ASTEC_ERGO_CLINICAL_STATEMENT_TEMPLATE")
@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
public abstract class ClinicalStatementTemplate extends ERGOClass {

	/** The original text. */
	@Column(name = "ORIGINAL_TEXT")
	protected String	originalText;

	/** The reference file. */
	@Column(name = "REFERENCE_FILE")
	protected String	referenceFile;

	/** The reference number. */
	@Column(name = "REFERENCE_NUMBER")
	protected String	referenceNumber;

	/** The template id. */
	@Column(name = "TEMPLATE_ID")
	protected Long		templateId;

	/** The atomic. */
	@Column(name = "ATOMIC")
	protected boolean	atomic;

	/**
	 * Instantiates a new clinical statement template.
	 */
	public ClinicalStatementTemplate() {
		atomic = false;
	}

	/**
	 * Gets the original text.
	 * 
	 * @return the original text
	 */
	public String getOriginalText() {
		return originalText;
	}

	/**
	 * Sets the original text.
	 * 
	 * @param originalText
	 *            the new original text
	 */
	public void setOriginalText(String originalText) {
		this.originalText = originalText;
	}

	/**
	 * Gets the reference file.
	 * 
	 * @return the reference file
	 */
	public String getReferenceFile() {
		return referenceFile;
	}

	/**
	 * Sets the reference file.
	 * 
	 * @param referenceFile
	 *            the new reference file
	 */
	public void setReferenceFile(String referenceFile) {
		this.referenceFile = referenceFile;
	}

	/**
	 * Gets the reference number.
	 * 
	 * @return the reference number
	 */
	public String getReferenceNumber() {
		return referenceNumber;
	}

	/**
	 * Sets the reference number.
	 * 
	 * @param referenceNumber
	 *            the new reference number
	 */
	public void setReferenceNumber(String referenceNumber) {
		this.referenceNumber = referenceNumber;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "ClinicalStatementTemplate [id=" + id + ", originalText=" + originalText + ", referenceFile=" + referenceFile + ", referenceNumber=" + referenceNumber + "]";
	}

	/**
	 * Gets the template id.
	 * 
	 * @return the template id
	 */
	public Long getTemplateId() {
		return templateId;
	}

	/**
	 * Sets the template id.
	 * 
	 * @param templateId
	 *            the new template id
	 */
	public void setTemplateId(final Long templateId) {
		this.templateId = templateId;
	}

	/**
	 * Checks if is atomic.
	 * 
	 * @return the atomic
	 */
	public boolean isAtomic() {
		return atomic;
	}

	/**
	 * Sets the atomic.
	 * 
	 * @param atomic
	 *            the atomic to set
	 */
	public void setAtomic(boolean atomic) {
		this.atomic = atomic;
	}

}