/*
 * 
 */
package fr.astec.entity.ergo.statement;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import fr.astec.entity.ergo.ERGOClass;
import fr.astec.entity.ergo.expression.NounPhrase;

// TODO: Auto-generated Javadoc
/**
 * The Class HealthcareStatement.
 * 
 * @author Laurent CHARLOIS
 * @version 1.0
 */
@Entity
@Table(name = "ASTEC_ERGO_HEALTHCARE_STATEMENT")
@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
public class HealthcareStatement extends SimpleClinicalStatement {

	/** The type. */
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "TYPE", referencedColumnName = "ERGO_CLASS_ID")
	protected NounPhrase	type;

	/**
	 * Gets the type.
	 * 
	 * @return the type
	 */
	public NounPhrase getType() {
		return type;
	}

	/**
	 * Sets the type.
	 * 
	 * @param type
	 *            the new type
	 */
	public void setType(NounPhrase type) {
		this.type = type;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * fr.astec.ergo.statement.SimpleClinicalStatement#toOWL(java.lang.String)
	 */
	@Override
	public String toOWL(String prefix) {
		StringBuilder sb = new StringBuilder();
		sb.append("<" + prefix + "HealthcareStatement rdf:ID=\"id_" + this.getId() + "\">");
		if (date != null) {
			sb.append("\n");
			sb.append("\t");
			sb.append("<" + prefix + "date>" + date.toOWL(prefix) + "</" + prefix + "date>");
		}
		if (nounPhrase != null) {
			sb.append("\n");
			sb.append("\t");
			sb.append("<" + prefix + "nounPhrase>" + nounPhrase.toOWL(prefix) + "</" + prefix + "nounPhrase>");
		}
		if (type != null) {
			sb.append("\n");
			sb.append("\t");
			sb.append("<" + prefix + "type>" + type.toOWL(prefix) + "</" + prefix + "type>");
		}
		sb.append("\n");
		sb.append("</" + prefix + "HealthcareStatement>");
		sb.append("\n");
		return sb.toString();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.astec.ergo.statement.SimpleClinicalStatement#toString()
	 */
	@Override
	public String toString() {
		return "HealthcareStatement [type=" + type + ", toString()=" + super.toString() + "]";
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * fr.astec.ergo.statement.SimpleClinicalStatement#getConstraintForAttribute
	 * (java.lang.String)
	 */
	@Override
	public ERGOClass getConstraintForAttribute(String attributeName) throws Exception {
		try {
			return super.getConstraintForAttribute(attributeName);
		} catch (Exception e) {
			if (attributeName.equals("type")) {
				return type;
			}
			e.getMessage().concat("\nL'attribut \'" + attributeName + "\' n'existe pas dans la classe \'" + this.getClass() + "\'");
			throw e;
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * fr.astec.ergo.statement.SimpleClinicalStatement#setConstraintForAttribute
	 * (java.lang.String, fr.astec.ergo.ERGOClass)
	 */
	@Override
	public void setConstraintForAttribute(String attributeName, ERGOClass constraint) throws Exception {
		try {
			super.setConstraintForAttribute(attributeName, constraint);
		} catch (Exception e) {
			if (attributeName.equals("type")) {
				type = (NounPhrase) constraint;
				return;
			}
			e.getMessage().concat("\nL'attribut \'" + attributeName + "\' n'existe pas dans la classe \'" + this.getClass() + "\'");
			throw e;
		}
	}
}
