/*
 * 
 */
package fr.astec.entity.ergo.statement;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import fr.astec.entity.ergo.ERGOClass;
import fr.astec.entity.ergo.constraint.SingleValueConstraint;
import fr.astec.entity.ergo.constraint.ValueConstraint;
import fr.astec.entity.ergo.expression.NounPhrase;

// TODO: Auto-generated Javadoc
/**
 * The Class SimpleClinicalStatement.
 * 
 * @author Laurent
 * @version 1.0
 * @created 20-mai-2010 15:34:39
 */
@Entity
@Table(name = "ASTEC_ERGO_SIMPLE_CLINICAL_STATEMENT")
@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
public class SimpleClinicalStatement extends ClinicalStatementTemplate {

	/** Expression ou Constraint. */
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "DATE", referencedColumnName = "ERGO_CLASS_ID")
	protected SingleValueConstraint	date;

	/** The noun phrase. */
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "NOUN_PHRASE", referencedColumnName = "ERGO_CLASS_ID")
	protected NounPhrase			nounPhrase;

	/**
	 * Gets the date.
	 * 
	 * @return the date
	 */
	public ValueConstraint getDate() {
		return date;
	}

	/**
	 * Sets the date.
	 * 
	 * @param date
	 *            the new date
	 */
	public void setDate(final ValueConstraint date) {
		this.date = (SingleValueConstraint) date;
	}

	/**
	 * Gets the noun phrase.
	 * 
	 * @return the noun phrase
	 */
	public NounPhrase getNounPhrase() {
		return nounPhrase;
	}

	/**
	 * Sets the noun phrase.
	 * 
	 * @param nounPhrase
	 *            the new noun phrase
	 */
	public void setNounPhrase(final NounPhrase nounPhrase) {
		this.nounPhrase = nounPhrase;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.astec.ergo.ERGOClass#toOWL(java.lang.String)
	 */
	@Override
	public String toOWL(final String prefix) {
		StringBuilder sb = new StringBuilder();
		sb.append("<" + prefix + "SimpleClinicalStatement rdf:ID=\"id_" + this.getId() + "\">");
		if (date != null) {
			sb.append("\n");
			sb.append("\t");
			sb.append("<" + prefix + "date>" + date.toOWL(prefix) + "</" + prefix + "date>");
		}
		if (nounPhrase != null) {
			sb.append("\n");
			sb.append("\t");
			sb.append("<" + prefix + "nounPhrase>" + nounPhrase.toOWL(prefix) + "</" + prefix + "nounPhrase>");
		}
		sb.append("\n");
		sb.append("</" + prefix + "SimpleClinicalStatement>");
		sb.append("\n");
		return sb.toString();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.astec.ergo.statement.ClinicalStatementTemplate#toString()
	 */
	@Override
	public String toString() {
		return "SimpleClinicalStatement [date=" + date + ", nounPhrase=" + nounPhrase + ", templateId=" + templateId + ", toString()=" + super.toString() + "]";
	}

	/**
	 * Gets the constraint for attribute.
	 * 
	 * @param attributeName
	 *            the attribute name
	 * @return the constraint for attribute
	 * @throws Exception
	 *             the exception
	 */
	public ERGOClass getConstraintForAttribute(String attributeName) throws Exception {
		if (attributeName.equals("date")) {
			return date;
		}
		if (attributeName.equals("code")) {
			return nounPhrase;
		}
		throw new Exception("L'attribut \'" + attributeName + "\' n'existe pas dans la classe \'" + this.getClass() + "\'");
	}

	/**
	 * Sets the constraint for attribute.
	 * 
	 * @param attributeName
	 *            the attribute name
	 * @param constraint
	 *            the constraint
	 * @throws Exception
	 *             the exception
	 */
	public void setConstraintForAttribute(String attributeName, ERGOClass constraint) throws Exception {
		if (attributeName.equals("date")) {
			date = (SingleValueConstraint) constraint;
			return;
		}
		if (attributeName.equals("code")) {
			nounPhrase = (NounPhrase) constraint;
			return;
		}
		throw new Exception("L'attribut \'" + attributeName + "\' n'existe pas dans la classe \'" + this.getClass() + "\'");
	}

	/**
	 * Gets the constraint for attribute.
	 * 
	 * @param id
	 *            the id
	 * @return the constraint for attribute
	 * @throws Exception
	 */
	public ERGOClass getConstraintForAttribute(Long id) throws Exception {
		throw new Exception("L'attribut avec l'id\'" + id + "\' n'existe pas dans la classe \'" + this.getClass() + "\'");
	}

	/**
	 * @param valueOf
	 * @param newComplexConstraint
	 * @throws Exception
	 */
	public void setConstraintForAttribute(Long id, ERGOClass constraint) throws Exception {
		throw new Exception("L'attribut avec l'id\'" + id + "\' n'existe pas dans la classe \'" + this.getClass() + "\'");
	}

}